<?php
extract($_POST);
extract($_GET);
$con = new mysqli('localhost', 'root', 'password','chat_db');

switch ($opt) 
{
    case "save":       
    $stmt = $con->prepare("INSERT INTO chat (sender,receiver,msg,time) values(?,?,?,NOW())");
    $stmt->bind_param("sss", $sender, $receiver, $msg);
    $stmt->execute();
    break;

    case "view_msg": 
    $result=array('status'=>false,'data'=>array());    
    $stmt = $con->prepare("SELECT chat.*,users.user_id FROM chat  LEFT JOIN users ON users.user_id=chat.sender"
        ." WHERE (receiver= ? AND sender= ? )"
        ." OR (receiver= ? AND sender= ? ) ORDER BY time");
    $stmt->bind_param("ssss", $sender, $receiver, $receiver, $sender);
    $stmt->execute();
    $r = $stmt->get_result();
    $messages=array();
    while ($row = $r->fetch_assoc()) {
        $messages[]=$row;
    }
    $result['status']=true;
    $result['data']['messages']=$messages;
    header('content-type:application/json');
    echo json_encode($result);
    break;
    
    case "get_chat":  
    $result=array('status'=>false,'data'=>array());       
    $stmt = $con->prepare("SELECT DISTINCT  sender from chat ".
        "  WHERE receiver= ? AND AddTime(time, '00:00:15')>=NOW()");
    $stmt->bind_param("s", $sender);       
    $stmt->execute();
    $r = $stmt->get_result();
    $users=array();
    while ($row = $r->fetch_assoc()) {  
        $users[]=$row;
    }
    $result['status']=true;
    $result['data']['users']=$users;
    header('content-type:application/json');
    echo json_encode($result);
    break;
    
    case "view_users":
    $result=array('status'=>false,'data'=>array());
    $stmt = $con->prepare("SELECT count(*) as count FROM users WHERE user_id= ?");
    $stmt->bind_param("s", $sender);       
    $stmt->execute();
    $r = $stmt->get_result();
    $row = $r->fetch_assoc();
    if($row['count']>0)
    {
        $stmt = $con->prepare("UPDATE users SET last_visit=NOW() WHERE user_id= ?");
        $stmt->bind_param("s", $sender);              
    }
    else
    {
        $stmt = $con->prepare("INSERT INTO users (user_id,last_visit) values(?,NOW())");
        $stmt->bind_param("s", $sender);
    }
    
    $stmt->execute();
    $stmt = $con->prepare("SELECT * FROM users WHERE AddTime(last_visit, '00:00:15')>=NOW()");
    $stmt->execute();
    $r = $stmt->get_result();
    $users=array();
    while ($row = $r->fetch_assoc()) {          
        $users[]=$row;
    }
    $result['status']=true;
    $result['data']['users']=$users;
    header('content-type:application/json');
    echo json_encode($result);
    
    break;
}
?>
